{
    "$graph": [
        {
            "class": "Workflow",
            "label": "varscan somatic workflow",
            "inputs": [
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#main/max_normal_freq"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/min_coverage"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#main/min_var_freq"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#main/normal_bam"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#main/p_value"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "id": "#main/reference"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/roi_bed"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/strand_filter"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#main/tumor_bam"
                }
            ],
            "steps": [
                {
                    "run": "#varscan_process_somatic.cwl",
                    "in": [
                        {
                            "source": "#main/max_normal_freq",
                            "id": "#main/process_somatic_indels/max_normal_freq"
                        },
                        {
                            "source": "#main/somatic/indels",
                            "id": "#main/process_somatic_indels/variants"
                        }
                    ],
                    "out": [
                        "#main/process_somatic_indels/somatic_hc",
                        "#main/process_somatic_indels/somatic",
                        "#main/process_somatic_indels/germline_hc",
                        "#main/process_somatic_indels/germline",
                        "#main/process_somatic_indels/loh_hc",
                        "#main/process_somatic_indels/loh"
                    ],
                    "id": "#main/process_somatic_indels"
                },
                {
                    "run": "#varscan_process_somatic.cwl",
                    "in": [
                        {
                            "source": "#main/max_normal_freq",
                            "id": "#main/process_somatic_snvs/max_normal_freq"
                        },
                        {
                            "source": "#main/somatic/snvs",
                            "id": "#main/process_somatic_snvs/variants"
                        }
                    ],
                    "out": [
                        "#main/process_somatic_snvs/somatic_hc",
                        "#main/process_somatic_snvs/somatic",
                        "#main/process_somatic_snvs/germline_hc",
                        "#main/process_somatic_snvs/germline",
                        "#main/process_somatic_snvs/loh_hc",
                        "#main/process_somatic_snvs/loh"
                    ],
                    "id": "#main/process_somatic_snvs"
                },
                {
                    "run": "#varscan_somatic.cwl",
                    "in": [
                        {
                            "source": "#main/min_coverage",
                            "id": "#main/somatic/min_coverage"
                        },
                        {
                            "source": "#main/min_var_freq",
                            "id": "#main/somatic/min_var_freq"
                        },
                        {
                            "source": "#main/normal_bam",
                            "id": "#main/somatic/normal_bam"
                        },
                        {
                            "source": "#main/p_value",
                            "id": "#main/somatic/p_value"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/somatic/reference"
                        },
                        {
                            "source": "#main/roi_bed",
                            "id": "#main/somatic/roi_bed"
                        },
                        {
                            "source": "#main/strand_filter",
                            "id": "#main/somatic/strand_filter"
                        },
                        {
                            "source": "#main/tumor_bam",
                            "id": "#main/somatic/tumor_bam"
                        }
                    ],
                    "out": [
                        "#main/somatic/snvs",
                        "#main/somatic/indels"
                    ],
                    "id": "#main/somatic"
                }
            ],
            "id": "#main",
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/process_somatic_indels/germline_hc",
                    "id": "#main/germline_hc_indels"
                },
                {
                    "type": "File",
                    "outputSource": "#main/process_somatic_snvs/germline_hc",
                    "id": "#main/germline_hc_snvs"
                },
                {
                    "type": "File",
                    "outputSource": "#main/process_somatic_indels/germline",
                    "id": "#main/germline_indels"
                },
                {
                    "type": "File",
                    "outputSource": "#main/process_somatic_snvs/germline",
                    "id": "#main/germline_snvs"
                },
                {
                    "type": "File",
                    "outputSource": "#main/somatic/indels",
                    "id": "#main/indels"
                },
                {
                    "type": "File",
                    "outputSource": "#main/process_somatic_indels/loh_hc",
                    "id": "#main/loh_hc_indels"
                },
                {
                    "type": "File",
                    "outputSource": "#main/process_somatic_snvs/loh_hc",
                    "id": "#main/loh_hc_snvs"
                },
                {
                    "type": "File",
                    "outputSource": "#main/process_somatic_indels/loh",
                    "id": "#main/loh_indels"
                },
                {
                    "type": "File",
                    "outputSource": "#main/process_somatic_snvs/loh",
                    "id": "#main/loh_snvs"
                },
                {
                    "type": "File",
                    "outputSource": "#main/somatic/snvs",
                    "id": "#main/snvs"
                },
                {
                    "type": "File",
                    "outputSource": "#main/process_somatic_indels/somatic_hc",
                    "id": "#main/somatic_hc_indels"
                },
                {
                    "type": "File",
                    "outputSource": "#main/process_somatic_snvs/somatic_hc",
                    "id": "#main/somatic_hc_snvs"
                },
                {
                    "type": "File",
                    "outputSource": "#main/process_somatic_indels/somatic",
                    "id": "#main/somatic_indels"
                },
                {
                    "type": "File",
                    "outputSource": "#main/process_somatic_snvs/somatic",
                    "id": "#main/somatic_snvs"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "varscan v2.4.2 processSomatic",
            "arguments": [
                "cp",
                "$(inputs.variants.path)",
                "$(runtime.outdir)/$(inputs.variants.basename)",
                {
                    "valueFrom": " && ",
                    "shellQuote": false
                },
                "java",
                "-jar",
                "/opt/varscan/VarScan.jar",
                "processSomatic"
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/cle:v1.3.1"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "--max-normal-freq",
                        "position": 2
                    },
                    "id": "#varscan_process_somatic.cwl/max_normal_freq"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "valueFrom": "$(runtime.outdir)/$(self.basename)",
                        "position": 1
                    },
                    "id": "#varscan_process_somatic.cwl/variants"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.Germline.vcf"
                    },
                    "id": "#varscan_process_somatic.cwl/germline"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.Germline.hc.vcf"
                    },
                    "id": "#varscan_process_somatic.cwl/germline_hc"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.LOH.vcf"
                    },
                    "id": "#varscan_process_somatic.cwl/loh"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.LOH.hc.vcf"
                    },
                    "id": "#varscan_process_somatic.cwl/loh_hc"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.Somatic.vcf"
                    },
                    "id": "#varscan_process_somatic.cwl/somatic"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.Somatic.hc.vcf"
                    },
                    "id": "#varscan_process_somatic.cwl/somatic_hc"
                }
            ],
            "id": "#varscan_process_somatic.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "varscan v2.4.2 somatic",
            "baseCommand": "varscan_helper.sh",
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 12000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/cle:v1.3.1"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "varscan_helper.sh",
                            "entry": "#!/bin/bash\n\nset -o errexit\nset -o nounset\n\nif [ $# -lt 7 ]\nthen\n    echo \"Usage: $0 [TUMOR_BAM] [NORMAL_BAM] [REFERENCE] [STRAND_FILTER] [MIN_COVERAGE] [MIN_VAR_FREQ] [P_VALUE] [roi_bed?]\"\n    exit 1\nfi\n\nTUMOR_BAM=\"$1\"\nNORMAL_BAM=\"$2\"\nREFERENCE=\"$3\"\nSTRAND_FILTER=\"$4\"\nMIN_COVERAGE=\"$5\"\nMIN_VAR_FREQ=\"$6\"\nP_VALUE=\"$7\"\nOUTPUT=\"${HOME}/output\"\n\nif [ -z ${8+x} ]\nthen\n    #run without ROI\n    java -jar /opt/varscan/VarScan.jar somatic \\\n        <(/opt/samtools/bin/samtools mpileup --no-baq -f \"$REFERENCE\" \"$NORMAL_BAM\" \"$TUMOR_BAM\") \\\n        $OUTPUT \\\n        --strand-filter $STRAND_FILTER \\\n        --min-coverage $MIN_COVERAGE \\\n        --min-var-freq $MIN_VAR_FREQ \\\n        --p-value $P_VALUE \\\n        --mpileup 1 \\\n        --output-vcf\nelse\n    ROI_BED=\"$8\"\n    java -jar /opt/varscan/VarScan.jar somatic \\\n        <(/opt/samtools/bin/samtools mpileup --no-baq -l \"$ROI_BED\" -f \"$REFERENCE\" \"$NORMAL_BAM\" \"$TUMOR_BAM\") \\\n        $OUTPUT \\\n        --strand-filter $STRAND_FILTER \\\n        --min-coverage $MIN_COVERAGE \\\n        --min-var-freq $MIN_VAR_FREQ \\\n        --p-value $P_VALUE \\\n        --mpileup 1 \\\n        --output-vcf\nfi\n"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 8,
                    "inputBinding": {
                        "position": 5
                    },
                    "id": "#varscan_somatic.cwl/min_coverage"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0.1,
                    "inputBinding": {
                        "position": 6
                    },
                    "id": "#varscan_somatic.cwl/min_var_freq"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#varscan_somatic.cwl/normal_bam"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0.99,
                    "inputBinding": {
                        "position": 7
                    },
                    "id": "#varscan_somatic.cwl/p_value"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#varscan_somatic.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 8
                    },
                    "id": "#varscan_somatic.cwl/roi_bed"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#varscan_somatic.cwl/strand_filter"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#varscan_somatic.cwl/tumor_bam"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "output.indel.vcf"
                    },
                    "id": "#varscan_somatic.cwl/indels"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "output.snp.vcf"
                    },
                    "id": "#varscan_somatic.cwl/snvs"
                }
            ],
            "id": "#varscan_somatic.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
